<?php
namespace Service\Calc;

use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
/**
*
* Interface to calculate
* planed, spend, Remaining
*/
class TaskCalculatorImpl implements TaskCalculator
{
    private $hourCalcStrategyFactory;

    public function __construct(\Service\Calc\Strategy\HourCalcStrategyFactory $hourCalcStrategyFactory)
    {
        $this->hourCalcStrategyFactory = $hourCalcStrategyFactory;
    }

    /**
     * @param \Service\Calc\Strategy\HourCalcStrategyInterface $strategy
     * @param \Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Calc\TaskInterface $task
     */
    private function doCalc($strategy, $task)
    {
        $task->setPlanned($strategy->planned($task));
        $task->setSpend($strategy->spend($task));
        $task->setRemaining($strategy->remaining($task));
        $percentCompleted = $strategy->percentCompleted($task);
        $percentCompleted = intval("$percentCompleted");
        $task->setPercentCompleted($percentCompleted);
        $task->setProgress($strategy->progress($task));

    }

    /**
     * @param Entities\Task $task
     */
    public function calculate($task)
    {
        if (empty($task->wasCalcalated) && $task->allowEndTask() == 'Y') {
            $task->wasCalcalated = true;
            $strategy = $this->hourCalcStrategyFactory->factoryCalc($task);
            $this->doCalc($strategy, $task);
            $task->setInCalc('N');
        }
        if ($task && $task->hasParent()) {
            $this->calculate($task->parent());
        }
    }
}