<?php

namespace Service;

use Doctrine\ORM\EntityManager;

class ProjectBurndown {

    protected  $entityManager;
    protected  $environment;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Repositories\Task $taskRepository */
    protected $taskRepository;    

    public function __construct(EntityManager $entityManager){
        $this->entityManager = $entityManager;
        $this->taskRepository = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Task');
    }

    public function saveProjectBurndown($projectId){
        $project = $this->entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Project', $projectId);
        $start = $project->getBeginDate();
        $end = $project->getEstimatedDate();

        $date = new \DateTime();
        if ($end > $date) {
            $end = $date;
        }

        $oneday = new \DateInterval("P1D");

        $days = array();
        $data = "7.5";

        $totalNumberTask = $this->taskRepository->getTotalNumberTask($project->getTreeKey());
        $projectBurndownFactory = new \Factory\ProjectBurndown($this->entityManager);

        foreach(new \DatePeriod($start, $oneday, $end->add($oneday)) as $day) {
            $day_num = $day->format("N"); /* 'N' number days 1 (mon) to 7 (sun) */
            if($day_num < 6) { /* weekday */
                $remainingExecuted = $totalNumberTask - $this->taskRepository->getRemainingExecutedNumberTask($project->getTreeKey(), $start, $day);
                $remainingPlanned = $totalNumberTask - $this->taskRepository->getRemainingPlannedNumberTask($project->getTreeKey(), $start, $day);

                $projectBurndown = $projectBurndownFactory->create($project, $day, 'TK', $totalNumberTask, $remainingPlanned, $remainingExecuted);
                $this->entityManager->persist($projectBurndown);
            } 
        }    

        $this->entityManager->flush();
        echo 'Function executed with success!!!';

        return $projectBurndown;
    }

/*    public function getTasksValues($project, $day, $burndownType) {
        if ($burndownType = 'TK') {
            return $taskRepository->getBurndownNumberTaskValues($project->getTreeKey(), $day);
        } else {
            return $taskRepository->getBurndownTimeTaskValues($project->getTreeKey(), $day);
        }
    }*/
} 