/* Tabela CCTBIMPFORN: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela CCTBIMPFORN */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CCTBIMPFORN utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_CCTBIMPFORN
AFTER DELETE OR INSERT OR UPDATE
ON CCTBIMPFORN FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || 'CdImp=' || :OLD.CDIMPOSTO;
      END IF;

      IF :OLD.IDTPIJURIMPO IS NOT NULL THEN
         V_DESC := V_DESC || ' TpPessoa=' || :OLD.IDTPIJURIMPO;
      END IF;

      IF :OLD.CDCCTBATIVIF IS NOT NULL THEN
         V_DESC := V_DESC || ' A recup=' || :OLD.CDCCTBATIVIF;
      END IF;

      IF :OLD.CDCCTBDADMIF IS NOT NULL THEN
         V_DESC := V_DESC || ' DespTrib=' || :OLD.CDCCTBDADMIF;
      END IF;

      IF :OLD.CDCCTBPASSIF IS NOT NULL THEN
         V_DESC := V_DESC || ' A recol=' || :OLD.CDCCTBPASSIF;
      END IF;

      IF :OLD.CDCCTBDESPIF IS NOT NULL THEN
         V_DESC := V_DESC || ' SobreVend=' || :OLD.CDCCTBDESPIF;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDIMPOSTO || :OLD.IDTPIJURIMPO;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDIMPOSTO     <> :NEW.CDIMPOSTO)    OR
            (NVL(:OLD.IDTPIJURIMPO,'!')  <> NVL(:NEW.IDTPIJURIMPO,'!')) OR
            (NVL(:OLD.CDCCTBATIVIF,'!')  <> NVL(:NEW.CDCCTBATIVIF,'!')) OR
            (NVL(:OLD.CDCCTBDADMIF,'!')  <> NVL(:NEW.CDCCTBDADMIF,'!')) OR
            (NVL(:OLD.CDCCTBPASSIF,'!')  <> NVL(:NEW.CDCCTBPASSIF,'!')) OR
            (NVL(:OLD.CDCCTBDESPIF,'!')  <> NVL(:NEW.CDCCTBDESPIF,'!')) THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDIMPOSTO || :OLD.IDTPIJURIMPO;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDIMPOSTO || :NEW.IDTPIJURIMPO;
      END IF;
      IF NVL(:OLD.CDIMPOSTO,'!')    <> NVL(:NEW.CDIMPOSTO,'!') THEN
         V_DESC := V_DESC || 'CdImp=' || :NEW.CDIMPOSTO;
      END IF;

      IF NVL(:OLD.IDTPIJURIMPO,'!') <> NVL(:NEW.IDTPIJURIMPO,'!') THEN
         V_DESC := V_DESC || ' TpPessoa=' || :NEW.IDTPIJURIMPO;
      END IF;

      IF NVL(:OLD.CDCCTBATIVIF,'!') <> NVL(:NEW.CDCCTBATIVIF,'!') THEN
         V_DESC := V_DESC || ' A recup=' || :NEW.CDCCTBATIVIF;
      END IF;

      IF NVL(:OLD.CDCCTBDADMIF,'!') <> NVL(:NEW.CDCCTBDADMIF,'!') THEN
         V_DESC := V_DESC || ' DespTrib=' || :NEW.CDCCTBDADMIF;
      END IF;

      IF NVL(:OLD.CDCCTBPASSIF,'!') <> NVL(:NEW.CDCCTBPASSIF,'!') THEN
         V_DESC := V_DESC || ' A recol=' || :NEW.CDCCTBPASSIF;
      END IF;

      IF NVL(:OLD.CDCCTBDESPIF,'!') <> NVL(:NEW.CDCCTBDESPIF,'!') THEN
         V_DESC := V_DESC || ' SobreVend=' || :NEW.CDCCTBDESPIF;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CCTBIMPFORN',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_CCTBIMPFORN','4.09.060'); END;
/
